<script setup>
import { ref, computed } from 'vue';
import { reslocked } from 'ui/itemsBase';
import { formatNumber } from '../../util/format';
import { useRollOver } from '../../store/popups';

/**
 * @property {string} group - displayed group name.
 * @property {object<string,boolean>} - elements to hide.
 */
const props = defineProps(['items', 'group', 'hide']);

const { itemOver } = useRollOver();

const isOpen = ref(true);

const shown = computed(() => {

	const a = [];
	const len = props.items.length;
	for (let i = 0; i < len; i++) {

		const it = props.items[i];
		if (!reslocked(it) && !props.hide[it.id]) {
			a.push(it);
		}
	}

	return a;

})

</script>

<template>

<div v-if="shown.length > 0">

	<div class="groupTitle separate" @click="isOpen = !isOpen">
		<span>{{ group }}</span>
		<span class="arrows">{{ isOpen ? '▼' : '▲' }}</span>
	</div>
	<div v-if="isOpen">

			<div class="rsrc separate hidable" v-for="it in shown"
				:data-key="it.id" :key="it.id"
				@mouseenter.capture.stop="itemOver($event, it)">

				<span class="item-name">{{ it.name }}</span>
				<span class="num-align">{{ formatNumber(it.value) + (it.max && it.max.value > 0 ? '/' + formatNumber(it.max.value) : '') }}</span>
				<!--<td>{{ it.delta != 0 ? '&nbsp;(' + it.delta.toFixed(2) + '/t )' : ''}}</td>-->

			</div>
	</div>
</div>
</template>

<style scoped>
div.groupTitle {
	cursor: pointer;
	text-transform: capitalize;
	color: var(--title-text-color);
	border: 1px solid var(--list-header-border);
	background-color: var(--list-header-color);
	padding: 1px;
	margin: -1px 0 0 0px;
}


@supports (-moz-appearance:button) and (contain:paint) {
	div.groupTitle {
		cursor: pointer;
		text-transform: capitalize;
		color: var(--title-text-color);
		border: 1px solid var(--list-header-border);
		background-color: var(--list-header-color);
	}
}

.rsrc .item-name {
	flex: 1;
	color: #999;
	padding-right: var(--sm-gap);
}
</style>